Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class TextFragmentValue

    java.lang.Object
      net.sf.saxon.value.TextFragmentValue

All Implemented Interfaces:
  Source, SourceLocator, PullEvent, DocumentInfo, FingerprintedNode, Item<NodeInfo>, NodeInfo, ValueRepresentation<NodeInfo>

    public final class TextFragmentValue

extends Object
implements DocumentInfo, FingerprintedNode, SourceLocator

This class represents a temporary tree whose root document node owns a single text node.

Field Summary

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`TextFragmentValue(CharSequence value, String baseURI)` Constructor: create a result tree fragment containing a single text node

Method Summary
`Value` | `atomize()` Get the typed value.
`int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`void` | `copy(Receiver out, int copyOptions, int locationId)` Copy the result tree fragment value to a given Outputter
`void` | `generateId(FastStringBuffer buffer)` Get a character string that uniquely identifies this node
`String` | `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`String` | `getAttributeValue(String uri, String local)` Get the string value of a given attribute of this node
`String` | `getBaseURI()` Get the base URI for the document node.
`int` | `getColumnNumber()` Return the character position where the current document event ends.
`Configuration` | `getConfiguration()` Get the configuration previously set using setConfiguration (or the default configuraton allocated automatically)
`NamespaceBinding[]` | `getDeclaredNamespaces(NamespaceBinding[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`String` | `getDisplayName()` Get the display name of this node.
`long` | `getDocumentNumber()` Get the unique document number
`DocumentInfo` | `getDocumentRoot()` Get the root (document) node
`int` | `getFingerprint()` Get the fingerprint of the node, used for matching names
`int` | `getLineNumber()` Get line number
`String` | `getLocalPart()` Get the local name of this node.
`int` | `getNameCode()` Get the name code of the node, used for displaying names
`NamePool` | `getNamePool()` Get the name pool used for the names in this document
`int` | `getNodeKind()` Return the type of node.
`NodeInfo` | `getParent()` Find the parent node of this node.
`String` | `getPrefix()` Get the prefix part of the name of this node.
`String` | `getPublicId()` Return the public identifier for the current document event.
`NodeInfo` | `getRoot()` Get the root node
`SchemaType` | `getSchemaType()` Get the type annotation of this node, if any.
`String` | `getStringValue()` Get the String Value
`CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
`String` | `getSystemId()` Get the system ID (the document URI) of the document node.
`int` | `getTypeAnnotation()` Get the type annotation of this node, if any.
`SequenceIterator` | `getTypedValue()` Get the typed value of the item
`String[]` | `getUnparsedEntity(String name)` Get the unparsed entity with a given name
`Iterator<String>` | `getUnparsedEntityNames()` Get the list of unparsed entities defined in this document
`String` | `getURI()` Get the URI part of the name of this node.
`Object` | `getUserData(String key)` Get user data held in the document node.
`boolean` | `hasChildNodes()` Determine whether the node has any children.
`boolean` | `isId()` Determine whether this node has the is-id property
`boolean` | `isIdref()` Determine whether this node has the is-idref property
`boolean` | `isNilled()` Determine whether the node has the is-nilled property
`boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node
`boolean` | `isTyped()` Ask whether the document contains any nodes whose type annotation is anything other than UNTYPED
`AxisIterator` | `iterateAxis(byte axisNumber)` Return an iteration over the nodes reached by the given axis from this node
`AxisIterator` | `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an enumeration over the nodes reached by the given axis from this node
`NodeInfo` | `selectID(String id, boolean getParent)` Get the element with a given ID.
`void` | `setConfiguration(Configuration config)` Set the configuration (containing the name pool used for all names in this document)
`void` | `setSystemId(String systemId)` Set the system ID (that is, the document URI property) for the document node.
`void` | `setUserData(String key, Object value)` Set user data on the document node.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.om.NodeInfo
`equals, hashCode`

Constructor Detail

### TextFragmentValue

    public TextFragmentValue(CharSequence value,
                             String baseURI)

  Constructor: create a result tree fragment containing a single text node

  Parameters:
    `value` - a String containing the value
    `baseURI` - the base URI of the document node

Method Detail

### setConfiguration

    public void setConfiguration(Configuration config)

  Set the configuration (containing the name pool used for all names in this document)

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration previously set using setConfiguration (or the default configuraton allocated automatically)

  Specified by:
    `getConfiguration` in interface `NodeInfo`
  Returns:
    the Configuration

### getNamePool

    public NamePool getNamePool()

  Get the name pool used for the names in this document

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Returns:
    the namepool

### isTyped

    public boolean isTyped()

  Ask whether the document contains any nodes whose type annotation is anything other than UNTYPED

  Specified by:
    `isTyped` in interface `DocumentInfo`
  Returns:
    true if the document contains elements whose type is other than UNTYPED

### getDocumentNumber

    public long getDocumentNumber()

  Get the unique document number

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`
  Returns:
    the document number of the document containing this node

### getNodeKind

    public final int getNodeKind()

  Return the type of node.

  Specified by:
    `getNodeKind` in interface `NodeInfo`
  Returns:
    Type.DOCUMENT (always)
  See Also:
    `Type`

### getStringValue

    public String getStringValue()

  Get the String Value

  Specified by:
    `getStringValue` in interface `Item<NodeInfo>`
  Specified by:
    `getStringValue` in interface `NodeInfo`
  Specified by:
    `getStringValue` in interface `ValueRepresentation<NodeInfo>`
  Returns:
    the string value of the node
  See Also:
    `Item.getStringValueCS()`

### getStringValueCS

    public CharSequence getStringValueCS()

  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item<NodeInfo>`
  Specified by:
    `getStringValueCS` in interface `ValueRepresentation<NodeInfo>`
  Returns:
    the string value of the item
  See Also:
    `Item.getStringValue()`

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node

  Specified by:
    `isSameNodeInfo` in interface `NodeInfo`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this Node object and the supplied Node object represent the same node in the tree.

### generateId

    public void generateId(FastStringBuffer buffer)

  Get a character string that uniquely identifies this node

  Specified by:
    `generateId` in interface `NodeInfo`
  Parameters:
    `buffer` - the buffer to contain the generated ID

### setSystemId

    public void setSystemId(String systemId)

  Set the system ID (that is, the document URI property) for the document node.

  Specified by:
    `setSystemId` in interface `Source`
  Throws:
    `UnsupportedOperationException` - (always). This kind of tree does not have a document URI.

### getSystemId

    public String getSystemId()

  Get the system ID (the document URI) of the document node.

  Specified by:
    `getSystemId` in interface `Source`
  Specified by:
    `getSystemId` in interface `SourceLocator`
  Specified by:
    `getSystemId` in interface `NodeInfo`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.

### getBaseURI

    public String getBaseURI()

  Get the base URI for the document node.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Returns:
    the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

### compareOrder

    public int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Specified by:
    `compareOrder` in interface `NodeInfo`
  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getNameCode

    public int getNameCode()

  Get the name code of the node, used for displaying names

  Specified by:
    `getNameCode` in interface `NodeInfo`
  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
  See Also:
    `allocate`, `getFingerprint`

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the node, used for matching names

  Specified by:
    `getFingerprint` in interface `NodeInfo`
  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.

### getPrefix

    public String getPrefix()

  Get the prefix part of the name of this node. This is the name before the ":" if any.

  Specified by:
    `getPrefix` in interface `NodeInfo`
  Returns:
    the prefix part of the name. For an unnamed node, return "".

### getURI

    public String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Specified by:
    `getURI` in interface `NodeInfo`
  Returns:
    The URI of the namespace of this node. For an unnamed node, or for an element or attribute in the default namespace, return an empty string.

### getDisplayName

    public String getDisplayName()

  Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.

  Specified by:
    `getDisplayName` in interface `NodeInfo`
  Returns:
    The display name of this node. For a node with no name, return an empty string.

### getLocalPart

    public String getLocalPart()

  Get the local name of this node.

  Specified by:
    `getLocalPart` in interface `NodeInfo`
  Returns:
    The local name of this node. For a node with no name, return "".

### hasChildNodes

    public boolean hasChildNodes()

  Determine whether the node has any children.

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Returns:
    `true` if this node has any attributes, `false` otherwise.

### getLineNumber

    public int getLineNumber()

  Get line number

  Specified by:
    `getLineNumber` in interface `SourceLocator`
  Specified by:
    `getLineNumber` in interface `NodeInfo`
  Returns:
    the line number of the node in its original source document; or -1 if not available

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of this node, if any. Returns XS_UNTYPED for kinds of nodes that have no annotation, and for elements annotated as untyped, and attributes annotated as untypedAtomic.

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Returns:
    the type annotation of the node.
  See Also:
    `Type`

### getSchemaType

    public SchemaType getSchemaType()

  Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

  Types derived from a DTD are not reflected in the result of this method.

  Specified by:
    `getSchemaType` in interface `NodeInfo`
  Returns:
    For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
  Since:
    9.4

### getDeclaredNamespaces

    public NamespaceBinding[] getDeclaredNamespaces(NamespaceBinding[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### getTypedValue

    public SequenceIterator getTypedValue()

  Get the typed value of the item

  Specified by:
    `getTypedValue` in interface `Item<NodeInfo>`
  Returns:
    the typed value of the item. In general this will be a sequence

### atomize

    public Value atomize()

  Get the typed value. The result of this method will always be consistent with the method `Item.getTypedValue()`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `NodeInfo`
  Returns:
    the typed value. If requireSingleton is set to true, the result will always be an AtomicValue. In other cases it may be a Value representing a sequence whose items are atomic values.
  Since:
    8.5

### getPublicId

    public String getPublicId()

  Return the public identifier for the current document event.

  The return value is the public identifier of the document entity or of the external parsed entity in which the markup that triggered the event appears.

  Specified by:
    `getPublicId` in interface `SourceLocator`
  Returns:
    A string containing the public identifier, or null if none is available.
  See Also:
    `getSystemId()`

### getColumnNumber

    public int getColumnNumber()

  Return the character position where the current document event ends.

  Warning: The return value from the method is intended only as an approximation for the sake of error reporting; it is not intended to provide sufficient information to edit the character content of the original XML document.

  The return value is an approximation of the column number in the document entity or external parsed entity where the markup that triggered the event appears.

  Specified by:
    `getColumnNumber` in interface `SourceLocator`
  Specified by:
    `getColumnNumber` in interface `NodeInfo`
  Returns:
    The column number, or -1 if none is available.
  See Also:
    `getLineNumber()`

### getAttributeValue

    public String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### getAttributeValue

    public String getAttributeValue(String uri,
                                    String local)

  Get the string value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
    `local` - the local part of the attribute name.
  Returns:
    the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
  Since:
    9.4

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an iteration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - The axis to be iterated over
  Returns:
    a AxisIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber,
                                    NodeTest nodeTest)

  Return an enumeration over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - The axis to be iterated over
    `nodeTest` - A pattern to be matched by the returned nodes
  Returns:
    a AxisIterator that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### getParent

    public NodeInfo getParent()

  Find the parent node of this node.

  Specified by:
    `getParent` in interface `NodeInfo`
  Returns:
    The Node object describing the containing element or root node.

### getRoot

    public NodeInfo getRoot()

  Get the root node

  Specified by:
    `getRoot` in interface `NodeInfo`
  Returns:
    the NodeInfo representing the root of this tree

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root (document) node

  Specified by:
    `getDocumentRoot` in interface `NodeInfo`
  Returns:
    the DocumentInfo representing the containing document

### copy

    public void copy(Receiver out,
                     int copyOptions,
                     int locationId)
              throws XPathException

  Copy the result tree fragment value to a given Outputter

  Specified by:
    `copy` in interface `NodeInfo`
  Parameters:
    `out` - the Receiver to which the node should be copied. It is the caller's responsibility to ensure that this Receiver is open before the method is called (or that it is self-opening), and that it is closed after use.
    `copyOptions` - a selection of the options defined in `CopyOptions`
    `locationId` - If non-zero, identifies the location of the instruction that requested this copy. If zero, indicates that the location information
  Throws:
    `XPathException` - if any downstream error occurs

### selectID

    public NodeInfo selectID(String id,
                             boolean getParent)

  Get the element with a given ID.

  Specified by:
    `selectID` in interface `DocumentInfo`
  Parameters:
    `id` - The unique ID of the required element
    `getParent` -
  Returns:
    null (this kind of tree contains no elements)

### getUnparsedEntityNames

    public Iterator<String> getUnparsedEntityNames()

  Get the list of unparsed entities defined in this document

  Specified by:
    `getUnparsedEntityNames` in interface `DocumentInfo`
  Returns:
    an Iterator, whose items are of type String, containing the names of all unparsed entities defined in this document. If there are no unparsed entities or if the information is not available then an empty iterator is returned

### getUnparsedEntity

    public String[] getUnparsedEntity(String name)

  Get the unparsed entity with a given name

  Specified by:
    `getUnparsedEntity` in interface `DocumentInfo`
  Parameters:
    `name` - the name of the entity
  Returns:
    the URI and public ID of the entity if there is one, or null if not

### isId

    public boolean isId()

  Determine whether this node has the is-id property

  Specified by:
    `isId` in interface `NodeInfo`
  Returns:
    true if the node is an ID

### isIdref

    public boolean isIdref()

  Determine whether this node has the is-idref property

  Specified by:
    `isIdref` in interface `NodeInfo`
  Returns:
    true if the node is an IDREF or IDREFS element or attribute

### isNilled

    public boolean isNilled()

  Determine whether the node has the is-nilled property

  Specified by:
    `isNilled` in interface `NodeInfo`
  Returns:
    true if the node has the is-nilled property

### setUserData

    public void setUserData(String key,
                            Object value)

  Set user data on the document node. The user data can be retrieved subsequently using `getUserData(java.lang.String)`

  Specified by:
    `setUserData` in interface `DocumentInfo`
  Parameters:
    `key` - A string giving the name of the property to be set. Clients are responsible for choosing a key that is likely to be unique. Must not be null. Keys used internally by Saxon are prefixed "saxon:".
    `value` - The value to be set for the property. May be null, which effectively removes the existing value for the property.

### getUserData

    public Object getUserData(String key)

  Get user data held in the document node. This retrieves properties previously set using `setUserData(java.lang.String, java.lang.Object)`

  Specified by:
    `getUserData` in interface `DocumentInfo`
  Parameters:
    `key` - A string giving the name of the property to be retrieved.
  Returns:
    the value of the property, or null if the property has not been defined.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.